Crypto++ 8.9 Free C++ class library of cryptographic schemes

Public Member Functions | List of all members
StringStore Class Reference

String-based implementation of Store interface. More...

Inheritance diagram for StringStore:

## Public Member Functions
| StringStore (const char *string=NULL)
| Construct a StringStore. More...
| StringStore (const byte *string, size_t length)
| Construct a StringStore. More...
template<class T >
| StringStore (const T &string)
| Construct a StringStore. More...
CRYPTOPP_DLL size_t | TransferTo2 (BufferedTransformation &target, lword &transferBytes, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer bytes from this object to another BufferedTransformation. More...
CRYPTOPP_DLL size_t | CopyRangeTo2 (BufferedTransformation &target, lword &begin, lword end=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true) const
| Copy bytes from this object to another BufferedTransformation. More...
Public Member Functions inherited from Store
| Store ()
| Construct a Store.
void | IsolatedInitialize (const NameValuePairs &parameters)
| Initialize or reinitialize this object, without signal propagation. More...
unsigned int | NumberOfMessages () const
| Provides the number of meesages processed by this object. More...
bool | GetNextMessage ()
| Start retrieving the next message. More...
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL) const
Public Member Functions inherited from AutoSignaling< InputRejecting< BufferedTransformation > >
| AutoSignaling (int propagation=-1)
| Construct an AutoSignaling. More...
void | SetAutoSignalPropagation (int propagation)
| Set propagation of automatically generated and transferred signals. More...
int | GetAutoSignalPropagation () const
| Retrieve automatic signal propagation value. More...
Public Member Functions inherited from InputRejecting< BufferedTransformation >
size_t | Put2 (const byte *inString, size_t length, int messageEnd, bool blocking)
| Input a byte array for processing. More...
bool | IsolatedFlush (bool hardFlush, bool blocking)
| Flushes data buffered by this object, without signal propagation. More...
bool | IsolatedMessageSeriesEnd (bool blocking)
| Marks the end of a series of messages, without signal propagation. More...
size_t | ChannelPut2 (const std::string &channel, const byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes for processing on a channel. More...
bool | ChannelMessageSeriesEnd (const std::string &channel, int messageEnd, bool blocking)
| Marks the end of a series of messages on a channel. More...
Public Member Functions inherited from BufferedTransformation
| BufferedTransformation ()
| Construct a BufferedTransformation.
BufferedTransformation & | Ref ()
| Provides a reference to this object. More...
virtual bool | Attachable ()
| Determines whether the object allows attachment. More...
virtual BufferedTransformation * | AttachedTransformation ()
| Returns the object immediately attached to this object. More...
virtual const BufferedTransformation * | AttachedTransformation () const
| Returns the object immediately attached to this object. More...
virtual void | Detach (BufferedTransformation *newAttachment=NULL)
| Delete the current attachment chain and attach a new one. More...
virtual void | Attach (BufferedTransformation *newAttachment)
| Add newAttachment to the end of attachment chain. More...
size_t | Put (byte inByte, bool blocking=true)
| Input a byte for processing. More...
size_t | Put (const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing. More...
size_t | PutWord16 (word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing. More...
size_t | PutWord32 (word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing. More...
size_t | PutWord64 (word64 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 64-bit word for processing. More...
virtual byte * | CreatePutSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual bool | CanModifyInput () const
| Determines whether input can be modified by the callee. More...
size_t | PutModifiable (byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee. More...
bool | MessageEnd (int propagation=-1, bool blocking=true)
| Signals the end of messages to the object. More...
size_t | PutMessageEnd (const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message. More...
virtual size_t | PutModifiable2 (byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee. More...
unsigned int | GetMaxWaitObjectCount () const
| Retrieves the maximum number of waitable objects.
void | GetWaitObjects (WaitObjectContainer &container, CallStack const &callStack)
| Retrieves waitable objects. More...
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| Initialize or reinitialize this object, with signal propagation. More...
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output, with signal propagation. More...
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| Marks the end of a series of messages, with signal propagation. More...
virtual lword | MaxRetrievable () const
| Provides the number of bytes ready for retrieval. More...
virtual bool | AnyRetrievable () const
| Determines whether bytes are ready for retrieval. More...
virtual size_t | Get (byte &outByte)
| Retrieve a 8-bit byte. More...
virtual size_t | Get (byte *outString, size_t getMax)
| Retrieve a block of bytes. More...
virtual size_t | Peek (byte &outByte) const
| Peek a 8-bit byte. More...
virtual size_t | Peek (byte *outString, size_t peekMax) const
| Peek a block of bytes. More...
size_t | GetWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 16-bit word. More...
size_t | GetWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 32-bit word. More...
size_t | GetWord64 (word64 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 64-bit word. More...
size_t | PeekWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 16-bit word. More...
size_t | PeekWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 32-bit word. More...
size_t | PeekWord64 (word64 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 64-bit word. More...
lword | TransferTo (BufferedTransformation &target, lword transferMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL)
| move transferMax bytes of the buffered output to target as input More...
virtual lword | Skip (lword skipMax=LWORD_MAX)
| Discard skipMax bytes from the output buffer. More...
lword | CopyTo (BufferedTransformation &target, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object to another BufferedTransformation. More...
lword | CopyRangeTo (BufferedTransformation &target, lword position, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object using an index to another BufferedTransformation. More...
virtual lword | TotalBytesRetrievable () const
| Provides the number of bytes ready for retrieval. More...
virtual bool | AnyMessages () const
| Determines if any messages are available for retrieval. More...
virtual unsigned int | SkipMessages (unsigned int count=UINT_MAX)
| Skip a number of meessages. More...
unsigned int | TransferMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL)
| Transfer messages from this object to another BufferedTransformation. More...
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation. More...
virtual void | SkipAll ()
| Skip all messages in the series.
void | TransferAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL)
| Transfer all bytes from this object to another BufferedTransformation. More...
void | CopyAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation. More...
virtual bool | GetNextMessageSeries ()
| Retrieve the next message in a series. More...
virtual unsigned int | NumberOfMessagesInThisSeries () const
| Provides the number of messages in a series. More...
virtual unsigned int | NumberOfMessageSeries () const
| Provides the number of messages in a series. More...
size_t | TransferMessagesTo2 (BufferedTransformation &target, unsigned int &messageCount, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer messages from this object to another BufferedTransformation. More...
size_t | TransferAllTo2 (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer all bytes from this object to another BufferedTransformation. More...
size_t | ChannelPut (const std::string &channel, byte inByte, bool blocking=true)
| Input a byte for processing on a channel. More...
size_t | ChannelPut (const std::string &channel, const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing on a channel. More...
size_t | ChannelPutModifiable (const std::string &channel, byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee on a channel. More...
size_t | ChannelPutWord16 (const std::string &channel, word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing on a channel. More...
size_t | ChannelPutWord32 (const std::string &channel, word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing on a channel. More...
size_t | ChannelPutWord64 (const std::string &channel, word64 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 64-bit word for processing on a channel. More...
bool | ChannelMessageEnd (const std::string &channel, int propagation=-1, bool blocking=true)
| Signal the end of a message. More...
size_t | ChannelPutMessageEnd (const std::string &channel, const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message. More...
virtual byte * | ChannelCreatePutSpace (const std::string &channel, size_t &size)
| Request space which can be written into by the caller. More...
virtual size_t | ChannelPutModifiable2 (const std::string &channel, byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee on a channel. More...
virtual bool | ChannelFlush (const std::string &channel, bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output on a channel. More...
virtual void | SetRetrievalChannel (const std::string &channel)
| Sets the default retrieval channel. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...
Public Member Functions inherited from Waitable
bool | Wait (unsigned long milliseconds, CallStack const &callStack)
| Wait on this object. More...

## Detailed Description

String-based implementation of Store interface.

Since
  Crypto++ 4.0

Definition at line 1258 of file filters.h.

## Constructor & Destructor Documentation

## ◆ StringStore() [1/3]

StringStore::StringStore | ( | const char * | string = `NULL` | ) |
| inline

Construct a StringStore.

Parameters

  string | pointer to a C-String

Definition at line 1263 of file filters.h.

## ◆ StringStore() [2/3]

StringStore::StringStore | ( | const byte * | string,
|  | size_t | length
| ) |  |
| inline

Construct a StringStore.

Parameters

  string | pointer to a memory buffer
  length | size of the memory buffer

Definition at line 1269 of file filters.h.

## ◆ StringStore() [3/3]

template<class T >

StringStore::StringStore | ( | const T & | string | ) |
| inline

Construct a StringStore.

Template Parameters

  T | std::basic_string<char> type

Parameters

  string | reference to a std::basic_string<char> type

Definition at line 1275 of file filters.h.

## Member Function Documentation

## ◆ TransferTo2()

CRYPTOPP_DLL size_t StringStore::TransferTo2 | ( | BufferedTransformation & | target,
|  | lword & | byteCount,
|  | const std::string & | channel = `DEFAULT_CHANNEL`,
|  | bool | blocking = `true`
| ) |  |
| virtual

Transfer bytes from this object to another BufferedTransformation.

Parameters

  target | the destination BufferedTransformation
  byteCount | the number of bytes to transfer
  channel | the channel on which the transfer should occur
  blocking | specifies whether the object should block when processing input

Returns
  the number of bytes that remain in the transfer block (i.e., bytes not transferred)

TransferTo2() removes bytes from this object and moves them to the destination. Transfer begins at the index position in the current stream, and not from an absolute position in the stream.

byteCount is an IN and OUT parameter. When the call is made, byteCount is the requested size of the transfer. When the call returns, byteCount is the number of bytes that were transferred.

Implements BufferedTransformation.

## ◆ CopyRangeTo2()

CRYPTOPP_DLL size_t StringStore::CopyRangeTo2 | ( | BufferedTransformation & | target,
|  | lword & | begin,
|  | lword | end = `LWORD_MAX`,
|  | const std::string & | channel = `DEFAULT_CHANNEL`,
|  | bool | blocking = `true`
| ) |  | const
| virtual

Copy bytes from this object to another BufferedTransformation.

Parameters

  target | the destination BufferedTransformation
  begin | the 0-based index of the first byte to copy in the stream
  end | the 0-based index of the last byte to copy in the stream
  channel | the channel on which the transfer should occur
  blocking | specifies whether the object should block when processing input

Returns
  the number of bytes that remain in the copy block (i.e., bytes not copied)

CopyRangeTo2 copies bytes from this object to the destination. The bytes are not removed from this object. Copying begins at the index position in the current stream, and not from an absolute position in the stream.

begin is an IN and OUT parameter. When the call is made, begin is the starting position of the copy. When the call returns, begin is the position of the first byte that was not copied (which may be different than end). begin can be used for subsequent calls to CopyRangeTo2().

Implements BufferedTransformation.

The documentation for this class was generated from the following file:

- filters.h